## exiv2 0.27.2

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 3.3.2 )

project(exiv2
    VERSION 0.27.2
    LANGUAGES CXX C
)

include(cmake/mainSetup.cmake  REQUIRED)

# options and their default values
option( BUILD_SHARED_LIBS             "Build exiv2lib as a shared library"                    ON  )
option( EXIV2_ENABLE_XMP              "Build with XMP metadata support"                       ON  )
option( EXIV2_ENABLE_EXTERNAL_XMP     "Use external version of XMP"                           OFF )
option( EXIV2_ENABLE_PNG              "Build with png support (requires libz)"                ON  )
option( EXIV2_ENABLE_NLS              "Build native language support (requires gettext)"      OFF )
option( EXIV2_ENABLE_PRINTUCS2        "Build with Printucs2"                                  ON  )
option( EXIV2_ENABLE_LENSDATA         "Build including lens data"                             ON  )
option( EXIV2_ENABLE_VIDEO            "Build video support into library"                      OFF )
option( EXIV2_ENABLE_DYNAMIC_RUNTIME  "Use dynamic runtime (used for static libs)"            ON )
option( EXIV2_ENABLE_WIN_UNICODE      "Use Unicode paths (wstring) on Windows"                OFF )
option( EXIV2_ENABLE_WEBREADY         "Build webready support into library"                   OFF )
option( EXIV2_ENABLE_CURL             "USE Libcurl for HttpIo (WEBREADY)"                     OFF )
option( EXIV2_ENABLE_SSH              "USE Libssh for SshIo (WEBREADY)"                       OFF )

option( EXIV2_BUILD_SAMPLES           "Build sample applications"                             ON  )
option( EXIV2_BUILD_EXIV2_COMMAND     "Build exiv2 command-line executable"                   ON  )
option( EXIV2_BUILD_UNIT_TESTS        "Build unit tests"                                      OFF )
option( EXIV2_BUILD_DOC               "Add 'doc' target to generate documentation"            OFF )

# Only intended to be used by Exiv2 developers/contributors
option( EXIV2_TEAM_EXTRA_WARNINGS     "Add more sanity checks using compiler flags"           OFF )
option( EXIV2_TEAM_WARNINGS_AS_ERRORS "Treat warnings as errors"                              OFF )
option( EXIV2_TEAM_USE_SANITIZERS     "Enable ASAN and UBSAN when available"                  OFF )
option( EXIV2_TEAM_PACKAGING          "Additional stuff for generating packages"              OFF )
set(EXTRA_COMPILE_FLAGS " ")

mark_as_advanced(
    EXIV2_TEAM_EXTRA_WARNINGS
    EXIV2_TEAM_WARNINGS_AS_ERRORS
    EXIV2_ENABLE_EXTERNAL_XMP
    EXTRA_COMPILE_FLAGS
    EXIV2_TEAM_USE_SANITIZERS
)

option( BUILD_WITH_CCACHE             "Use ccache to speed up compilations"                   OFF )
option( BUILD_WITH_COVERAGE           "Add compiler flags to generate coverage stats"         OFF )

set( PACKAGE_BUGREPORT                "http://github.com/exiv2/exiv2" )
set( PACKAGE_URL                      "http://exiv2.dyndns.org")
set( PROJECT_DESCRIPTION              "Exif and IPTC metadata library and tools")

if ( EXIV2_ENABLE_EXTERNAL_XMP )
    set(EXIV2_ENABLE_XMP OFF)
endif()

if( EXIV2_BUILD_UNIT_TESTS )
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON) # Requires CMake 3.3.3
endif()

include(cmake/findDependencies.cmake   REQUIRED)
include(cmake/compilerFlags.cmake      REQUIRED)
include(cmake/generateConfigFile.cmake REQUIRED)

if (EXIV2_BUILD_DOC)
    include(cmake/generateDoc.cmake        REQUIRED)
    generate_documentation("${PROJECT_SOURCE_DIR}/cmake/Doxyfile.in")
endif()


include_directories(${CMAKE_BINARY_DIR})  # Make the exv_conf.h file visible for the full project

if( EXIV2_ENABLE_XMP )
    add_subdirectory( xmpsdk )
endif()

include(cmake/compilerFlagsExiv2.cmake REQUIRED)

add_subdirectory( include )
add_subdirectory( src )

if( EXIV2_BUILD_UNIT_TESTS )
    add_subdirectory ( unitTests )
endif()

if( EXIV2_BUILD_SAMPLES )
    ##
    # tests
    add_custom_target(tests
        COMMAND env EXIV2_BINDIR="${CMAKE_RUNTIME_OUTPUT_DIRECTORY}" make test
        WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/test"
    )
    add_subdirectory( samples )
    get_directory_property(SAMPLES DIRECTORY samples DEFINITION APPLICATIONS)
    add_dependencies(tests exiv2lib exiv2 ${SAMPLES})
endif()

if( EXIV2_ENABLE_NLS )
    add_subdirectory( po )
endif()

if (EXIV2_TEAM_PACKAGING)
    include(cmake/packaging.cmake)
endif()

configure_file(cmake/exiv2.pc.in exiv2.pc @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/exiv2.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

include(cmake/printSummary.cmake)

# That's all Folks!
##

=== samples/CMakeLists.txt ===
# CMakeLists.txt for exiv2 library sample applications

set( SAMPLES
     addmoddel.cpp
     convert-test.cpp
     easyaccess-test.cpp
     exifcomment.cpp
     exifdata-test.cpp
     exifdata.cpp
     exifprint.cpp
     exifvalue.cpp
     ini-test.cpp
     iotest.cpp
     iptceasy.cpp
     iptcprint.cpp
     iptctest.cpp
     key-test.cpp
     largeiptc-test.cpp
     mmap-test.cpp
     mrwthumb.cpp
     prevtest.cpp
     stringto-test.cpp
     taglist.cpp
     tiff-test.cpp
     werror-test.cpp
     write-test.cpp
     write2-test.cpp
     xmpparse.cpp
     xmpparser-test.cpp
     xmpprint.cpp
     xmpsample.cpp
     xmpdump.cpp
)

##
# build samples AND add them to the APPLICATIONS list
foreach(entry ${SAMPLES})
    string( REPLACE ".cpp" "" target ${entry})
    add_executable( ${target} ${target}.cpp )
    set_target_properties(${target} PROPERTIES
      COMPILE_FLAGS ${EXTRA_COMPILE_FLAGS})
    list(APPEND APPLICATIONS ${target})
    add_test( ${target}_test ${target} )
    target_include_directories(${target} PRIVATE ${CMAKE_SOURCE_DIR}/src) # To find unused.h
    install( TARGETS ${target} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endforeach()

###################################

if (MSVC)
    link_directories(${CMAKE_INSTALL_PREFIX}/lib)
endif()

add_executable( getopt-test getopt-test.cpp ../src/utils.cpp ../src/getopt.cpp)
list(APPEND APPLICATIONS getopt-test)
target_include_directories(getopt-test PRIVATE ${CMAKE_SOURCE_DIR}/src) # To find utils.hpp

add_executable( metacopy metacopy.cpp ../src/utils.cpp ../src/getopt.cpp)
list(APPEND APPLICATIONS metacopy)
target_include_directories(metacopy PRIVATE ${CMAKE_SOURCE_DIR}/src) # To find utils.hpp

add_executable(          pathtest  path-test.cpp ../src/utils.cpp ../src/getopt.cpp)
list(APPEND APPLICATIONS pathtest)
set_target_properties(   pathtest  PROPERTIES OUTPUT_NAME path-test )
target_include_directories(pathtest PRIVATE ${CMAKE_SOURCE_DIR}/src) # To find utils.hpp

add_executable(          exiv2json exiv2json.cpp Jzon.cpp Jzon.h)
list(APPEND APPLICATIONS exiv2json)

install( TARGETS metacopy pathtest exiv2json RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

if( EXPAT_FOUND )
    add_executable(        geotag    geotag.cpp)
    list(APPEND APPLICATIONS geotag)
    target_link_libraries(geotag 
        PRIVATE
            exiv2-xmp
            ${EXPAT_LIBRARIES}
    )
    target_include_directories(geotag PRIVATE ${EXPAT_INCLUDE_DIR})
    target_include_directories(geotag PRIVATE ${CMAKE_SOURCE_DIR}/src) # To find unused.h

    if (WIN32)
        target_compile_definitions(geotag PRIVATE XML_STATIC)
    endif()

    if (MSVC)
        set_target_properties(geotag PROPERTIES LINK_FLAGS "/ignore:4099")
    endif()

    install( TARGETS       geotag    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

# ******************************************************************************
# connection test application
add_executable(conntest conntest.cpp)
list(APPEND APPLICATIONS conntest)

if (EXIV2_ENABLE_WEBREADY)
    if( EXIV2_ENABLE_CURL )
        target_include_directories(conntest SYSTEM PRIVATE ${CURL_INCLUDE_DIR} )
        target_link_libraries(conntest PRIVATE ${CURL_LIBRARIES})
        if (USING_CONAN)
            target_compile_definitions(conntest PRIVATE ${CONAN_COMPILE_DEFINITIONS_LIBCURL})
            target_link_libraries(conntest PRIVATE ${CONAN_EXE_LINKER_FLAGS_LIBCURL})
            if (NOT APPLE)
                target_link_libraries(conntest PRIVATE CONAN_PKG::OpenSSL)
            endif()
        endif()
    endif()
endif()

# ******************************************************************************
# remotetest application
add_executable(remotetest remotetest.cpp)
list(APPEND APPLICATIONS remotetest)

# ******************************************************************************
foreach(application ${APPLICATIONS})
    target_link_libraries(${application} PRIVATE exiv2lib)
    if( EXIV2_ENABLE_PNG )
        target_link_libraries( ${application} PRIVATE ${ZLIB_LIBRARIES} )
    endif()
endforeach()

# That's all Folks!
##

=== unitTests/CMakeLists.txt ===
find_package(GTest REQUIRED)

get_target_property(exiv2lib_SOURCES exiv2lib SOURCES)
get_target_property(exiv2lib_int_SOURCES exiv2lib_int SOURCES)
get_target_property(exiv2lib_COMPILE_DEFINITIONS exiv2lib COMPILE_DEFINITIONS)
get_target_property(exiv2lib_INCLUDE_DIRECTORIES exiv2lib INCLUDE_DIRECTORIES)
get_target_property(exiv2lib_LINK_LIBRARIES exiv2lib LINK_LIBRARIES)

set(unit_tests_exiv2lib_SOURCES)
foreach(source IN LISTS exiv2lib_SOURCES exiv2lib_int_SOURCES)
    if(source MATCHES "\.(c|cpp|h|hpp)$")
        if(source MATCHES ".*/.*")
            list(APPEND unit_tests_exiv2lib_SOURCES "${source}")
        else()
            list(APPEND unit_tests_exiv2lib_SOURCES "../src/${source}")
        endif()
    endif()
endforeach()

add_executable(unit_tests mainTestRunner.cpp
    gtestwrapper.h
    test_basicio.cpp
    test_types.cpp
    test_tiffheader.cpp
    test_futils.cpp
    test_enforce.cpp
    test_safe_op.cpp
    test_XmpKey.cpp
    test_DateValue.cpp
    test_TimeValue.cpp
    test_cr2header_int.cpp
    test_helper_functions.cpp
    test_slice.cpp
    test_image_int.cpp
    ${unit_tests_exiv2lib_SOURCES}
)

target_compile_definitions(unit_tests PRIVATE exiv2lib_STATIC)

if (exiv2lib_COMPILE_DEFINITIONS)
    target_compile_definitions(unit_tests PRIVATE ${exiv2lib_COMPILE_DEFINITIONS})
endif ()

target_include_directories(unit_tests
    PRIVATE
        ${exiv2lib_INCLUDE_DIRECTORIES}
)

#TODO Use GTest::GTest once we upgrade the minimum CMake version required
target_link_libraries(unit_tests
    PRIVATE
        ${exiv2lib_LINK_LIBRARIES}
        ${GTEST_BOTH_LIBRARIES}
)

# ZLIB is used in exiv2lib_int.
if( EXIV2_ENABLE_PNG )
    target_link_libraries(unit_tests PRIVATE ${ZLIB_LIBRARIES} )
endif()

target_include_directories(unit_tests
    PRIVATE
        ${GTEST_INCLUDE_DIRS}
        ${CMAKE_SOURCE_DIR}/src
)

target_compile_definitions(unit_tests
    PRIVATE
        GTEST_LINKED_AS_SHARED_LIBRARY=1
)

set_target_properties(unit_tests PROPERTIES
    COMPILE_FLAGS ${EXTRA_COMPILE_FLAGS}
)

if (USING_CONAN)
    target_compile_definitions(unit_tests PRIVATE ${CONAN_COMPILE_DEFINITIONS_GTEST})
endif()

if (MSVC)
    set_target_properties(unit_tests PROPERTIES LINK_FLAGS "/ignore:4099")
endif()

=== debian/changelog ===
exiv2 (0.27.2-8~mx17+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 27 Jul 2020 01:21:15 -0700

exiv2 (0.27.2-8) unstable; urgency=medium

  * Team upload.
  * Update symbols file from the logs of buildds.
  * Merge useful changes from 0.25-4:
    - add Maximiliano Curia as Uploader
    - adjust version of dbgsym migration
  * Drop the python:native build dependency, as it is not used.
    (Closes: #936496)
  * Sort install files.
  * Move the static libexiv2-xmp.a from libexiv2-27 to libexiv2-dev, as it is
    needed only for development
    - add proper breaks/replaces
  * The current way to build the API documentation is suboptimal: even in
    -indep builds a an -arch build is forced; also the separate doc build
    requires a custom patch, Instead:
    - move the common arguments for cmake to a variable to avoid duplication
    - pass -DEXIV2_BUILD_DOC=ON to enable the documentation build, unless on
      -arch builds
    - pass -DCMAKE_INSTALL_DOCDIR=/usr/share/doc/exiv2/html to cmake to change
      the installation directory of the documentation (mostly for the "html"
      part), and change libexiv2-doc.docs to pick it from that location
    - call the "doc" target in -indep builds
    - drop patch 0001-doc-only-build-target.patch, no more needed now
  * Remove patch numbers from patch files.
  * Backport upstream commits 4c28673b641d7eacb50baafb5c286f6900ce2002, and
    d4d4d766e9ade2376115eb41cc478eb195df1b39 to fix CVE-2019-9143 and
    CVE-2019-9144; patches Fix-issue-712.patch, and
    Add-comment-to-explain-choice-of-cut-off-value.patch.
    (Closes: #923472, #923473)
  * Backport upstream commit 1b917c3f7dd86336a9f6fda4456422c419dfe88c to fix
    CVE-2019-20421; patch Fix-1011-fix_1011_jp2_readmetadata_loop.patch.
    (Closes: #950183)
  * Add debian/source/include-binaries for the patches Fix-issue-712.patch, and
    Fix-1011-fix_1011_jp2_readmetadata_loop.patch, as they contain the binary
    testcases for the fixes.

 -- Pino Toscano <pino@debian.org>  Thu, 30 Jan 2020 09:39:44 +0100

exiv2 (0.27.2-7) unstable; urgency=medium

  * Team upload.
  * Update symbols file.
  * Remove the dh_missing --list-missing invocation, as it is done by default
    in debhelper compatibility 12.
  * Switch from the debhelper build dependency to debhelper-compat
    - remove debian/compat
  * Bump Standards-Version to 4.5.0, no changes required.
  * Remove trailing whitespaces in changelog.
  * Update lintian overrides.
  * Pass -DEXIV2_BUILD_SAMPLES=OFF to cmake to disable the build of samples,
    as we do not ship them anyway.
  * Remove debian/not-installed, no more needed now.
  * Drop removal of .la files, as they are not shipped anymore.
  * Add the configuration for the CI on salsa.
  * Use https for Homepage.
  * Tweak watch file to consider only digits and dots for versions.
  * Move translations from libexiv2-dev to the main library package, as they
    contain messages for the library and the exiv2 tool
    - add proper breaks/replaces

 -- Pino Toscano <pino@debian.org>  Tue, 28 Jan 2020 09:32:57 +0100

exiv2 (0.27.2-6) unstable; urgency=medium

  [ Steve Robbins ]
  * Source upload to unstable.  Closes: #914006, #926880.
  * Update symbols.

 -- Steve M. Robbins <smr@debian.org>  Mon, 27 Jan 2020 22:50:41 -0600

exiv2 (0.27.2-5) experimental; urgency=medium

  [ Steve Robbins ]
  * Update symbols

 -- Steve M. Robbins <smr@debian.org>  Sun, 26 Jan 2020 09:57:00 -0600

exiv2 (0.27.2-4) experimental; urgency=medium

  [ Steve Robbins ]
  * Add myself to uploaders
  * Fix SOVERSION in symbols file.

 -- Steve M. Robbins <smr@debian.org>  Sat, 25 Jan 2020 22:42:34 -0600

exiv2 (0.27.2-3) experimental; urgency=medium

  [ Steve Robbins ]
  * Updated symbol file from build server logs.

 -- Steve M. Robbins <smr@debian.org>  Wed, 06 Nov 2019 19:36:27 -0600

exiv2 (0.27.2-2) experimental; urgency=medium

  [ Jelmer Vernooĳ ]
  * Fix Vcs-Git and Vcs-Browser URLs.

  [ Steven Robbins ]
  * Revert symbols file to 0.25, in order to get diffs from build servers.

 -- Steve M. Robbins <smr@debian.org>  Mon, 04 Nov 2019 23:54:08 -0600

exiv2 (0.27.2-1) experimental; urgency=medium

  * Team upload.

  [ Maximiliano Curia ]
  * New revision
  * Update uploaders list as requested by MIA team (Closes: #879288)

  [ Simon Frei ]
  * New upstream release (0.27.2)
  * Drop upstream patches
  * Follow upstream soversion bump
  * Update build dependencies
  * Reenable XMP support
  * Bump debhelper from 9 to 12
  * Bump Standards-Version to 4.4.0 (no changes)
  * Various fixes due to lintian

 -- Steve M. Robbins <smr@debian.org>  Tue, 10 Sep 2019 00:05:18 -0500

=== debian/control ===
Source: exiv2
Section: graphics
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Mark Purcell <msp@debian.org>,
           Steve M. Robbins <smr@debian.org>,
           Maximiliano Curia <maxy@debian.org>
Build-Depends: chrpath,
               cmake,
               debhelper-compat (= 12),
               libexpat1-dev,
               pkg-kde-tools,
               zlib1g-dev
Build-Depends-Indep: doxygen, graphviz, libjs-jquery, xsltproc
Standards-Version: 4.5.0
Homepage: https://www.exiv2.org/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/exiv2
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/exiv2.git

Package: exiv2
Architecture: any
Depends: libexiv2-27 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: EXIF/IPTC/XMP metadata manipulation tool
 Exiv2 is a C++ library and a command line utility to manage image metadata.
 It provides fast and easy read and write access to the Exif, IPTC and XMP
 metadata of images in various formats
 .
 Exiv2 command line utility to:
 .
  * print Exif, IPTC and XMP image metadata in different formats:
    - Exif summary info, interpreted values, or the plain data for each tag
  * set, add and delete Exif, IPTC and XMP image metadata from command line
    modify commands or command scripts
  * adjust the Exif timestamp (that's how it all started...)
  * rename Exif image files according to the Exif timestamp
  * extract, insert and delete Exif, IPTC and XMP metadata and JPEG comments
  * extract previews from RAW images and thumbnails from the Exif metadata
  * insert and delete the thumbnail image embedded in the Exif metadata
  * print, set and delete the JPEG comment of JPEG images
  * fix the Exif ISO setting of picture taken with Canon and Nikon cameras

Package: libexiv2-27
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libexiv2-dev (<< 0.27.2-7~)
Replaces: libexiv2-dev (<< 0.27.2-7~)
Suggests: exiv2
Multi-Arch: same
Description: EXIF/IPTC/XMP metadata manipulation library
 Exiv2 is a C++ library and a command line utility to manage image metadata.
 It provides fast and easy read and write access to the Exif, IPTC and XMP
 metadata of images in various formats
 .
 Exiv2 library provides:
  * fast read and write access to the Exif, IPTC, and XMP metadata of an image
  * an easy to use and extensively documented API
  * conversions of Exif and IPTC metadata to XMP and vice versa
  * a smart IPTC implementation that does not affect data that programs like
    Photoshop store in the same image segment
  * Exif Makernote support:
    - Makernote tags can be read and written just like any other metadata
    - a sophisticated write algorithm avoids corrupting the Makernote
  * a simple interface to extract previews embedded in RAW images and Exif
    thumbnails
  * set and delete methods for Exif thumbnails

Package: libexiv2-dev
Section: libdevel
Architecture: any
Depends: libexiv2-27 (= ${binary:Version}), ${misc:Depends}
Breaks: libexiv2-27 (<< 0.27.2-8~)
Replaces: libexiv2-27 (<< 0.27.2-8~)
Suggests: libexiv2-doc
Description: EXIF/IPTC/XMP metadata manipulation library - development files
 Exiv2 is a C++ library and a command line utility to manage image metadata.
 It provides fast and easy read and write access to the Exif, IPTC and XMP
 metadata of images in various formats
 .
 This package provides the development files for using exiv2.

Package: libexiv2-doc
Depends: libjs-jquery, ${misc:Depends}
Section: doc
Architecture: all
Description: EXIF/IPTC/XMP metadata manipulation library - HTML documentation
 Exiv2 is a C++ library and a command line utility to manage image metadata.
 It provides fast and easy read and write access to the Exif, IPTC and XMP
 metadata of images in various formats
 .
 This package provides the Exiv2 HTML documentation.

=== debian/rules ===
#!/usr/bin/make -f

CMAKE_COMMON_ARGS = \
	-DEXIV2_ENABLE_NLS=ON \
	-DEXIV2_ENABLE_VIDEO=ON \
	-DEXIV2_ENABLE_WEBREADY=ON \
	-DEXIV2_BUILD_SAMPLES=OFF

%:
	dh $@ --with pkgkde_symbolshelper --buildsystem cmake

override_dh_auto_configure-indep:
	dh_auto_configure -- \
	    $(CMAKE_COMMON_ARGS) \
	    -DEXIV2_BUILD_DOC=ON \
	    -DCMAKE_INSTALL_DOCDIR=/usr/share/doc/exiv2/html

override_dh_auto_configure-arch:
	dh_auto_configure -a -- \
	    $(CMAKE_COMMON_ARGS)

override_dh_install:
	dh_install
	find $(CURDIR)/debian -type f -name exiv2 | xargs /usr/bin/chrpath -d

override_dh_auto_build-indep:
	dh_auto_build
	dh_auto_build -- doc

override_dh_installdocs:
	dh_installdocs -A -Xcmd.txt -XMakefile -Xtemplates -XChangeLog
	find $(CURDIR)/debian -name jquery.js -exec ln -sfv /usr/share/javascript/jquery/jquery.js {} \;
	find $(CURDIR)/debian \( -name '*.map' -o -name '*.md5' \) -delete

override_dh_installchangelogs:
	dh_installchangelogs -A doc/ChangeLog

override_dh_compress:
	dh_compress -X.xls -X.js -X.idx -X.xml -X.php -X.cpp

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## exiv2 0.27.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,14 @@
 cmake_minimum_required( VERSION 3.3.2 )
 
-project(exiv2
-    VERSION 0.27.2
+project(exiv2          # use TWEAK to categorize the build
+    VERSION 0.27.3     # 0.27.3    = GM
+                       # 0.27.3.00 = GM Preview
+                       # 0.27.3.09 = Not For Release
+                       # 0.27.3.2  = RC2
+                       # 0.27.3.20 = RC2 Preview
+                       # 0.27.3.29 = RC2 Not for release
     LANGUAGES CXX C
 )
-
 include(cmake/mainSetup.cmake  REQUIRED)
 
 # options and their default values
@@ -16,7 +20,7 @@
 option( EXIV2_ENABLE_PRINTUCS2        "Build with Printucs2"                                  ON  )
 option( EXIV2_ENABLE_LENSDATA         "Build including lens data"                             ON  )
 option( EXIV2_ENABLE_VIDEO            "Build video support into library"                      OFF )
-option( EXIV2_ENABLE_DYNAMIC_RUNTIME  "Use dynamic runtime (used for static libs)"            ON )
+option( EXIV2_ENABLE_DYNAMIC_RUNTIME  "Use dynamic runtime (used for static libs)"            ON  )
 option( EXIV2_ENABLE_WIN_UNICODE      "Use Unicode paths (wstring) on Windows"                OFF )
 option( EXIV2_ENABLE_WEBREADY         "Build webready support into library"                   OFF )
 option( EXIV2_ENABLE_CURL             "USE Libcurl for HttpIo (WEBREADY)"                     OFF )
@@ -80,15 +84,44 @@
 
 if( EXIV2_BUILD_UNIT_TESTS )
     add_subdirectory ( unitTests )
+    add_custom_target(unit_test
+        COMMAND env EXIV2_BINDIR="${CMAKE_RUNTIME_OUTPUT_DIRECTORY}" make unit_test
+        WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/test"
+    )
 endif()
+
+add_custom_target(version_test
+	COMMAND env EXIV2_BINDIR="${CMAKE_RUNTIME_OUTPUT_DIRECTORY}" make version_test
+	WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/test"
+)
 
 if( EXIV2_BUILD_SAMPLES )
     ##
     # tests
-    add_custom_target(tests
-        COMMAND env EXIV2_BINDIR="${CMAKE_RUNTIME_OUTPUT_DIRECTORY}" make test
-        WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/test"
-    )
+    if( EXIV2_BUILD_UNIT_TESTS )
+		add_custom_target(tests
+			COMMAND env EXIV2_BINDIR="${CMAKE_RUNTIME_OUTPUT_DIRECTORY}" make unit_test
+			COMMAND env EXIV2_BINDIR="${CMAKE_RUNTIME_OUTPUT_DIRECTORY}" make bash_tests
+		    COMMAND env EXIV2_BINDIR="${CMAKE_RUNTIME_OUTPUT_DIRECTORY}" make python_tests
+		    COMMAND env EXIV2_BINDIR="${CMAKE_RUNTIME_OUTPUT_DIRECTORY}" make version_test
+			WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/test"
+		)
+    else()
+		add_custom_target(tests
+			COMMAND env EXIV2_BINDIR="${CMAKE_RUNTIME_OUTPUT_DIRECTORY}" make bash_tests
+		    COMMAND env EXIV2_BINDIR="${CMAKE_RUNTIME_OUTPUT_DIRECTORY}" make python_tests
+		    COMMAND env EXIV2_BINDIR="${CMAKE_RUNTIME_OUTPUT_DIRECTORY}" make version_test
+			WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/test"
+		)
+    endif()
+	add_custom_target(python_tests
+		COMMAND env EXIV2_BINDIR="${CMAKE_RUNTIME_OUTPUT_DIRECTORY}" make python_tests
+		WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/test"
+	)
+	add_custom_target(bash_tests
+		COMMAND env EXIV2_BINDIR="${CMAKE_RUNTIME_OUTPUT_DIRECTORY}" make bash_tests
+		WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/test"
+	)
     add_subdirectory( samples )
     get_directory_property(SAMPLES DIRECTORY samples DEFINITION APPLICATIONS)
     add_dependencies(tests exiv2lib exiv2 ${SAMPLES})
@@ -103,7 +136,12 @@
 endif()
 
 configure_file(cmake/exiv2.pc.in exiv2.pc @ONLY)
-install(FILES ${CMAKE_BINARY_DIR}/exiv2.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/exiv2.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
+
+# ******************************************************************************
+# Man page
+install( FILES ${PROJECT_SOURCE_DIR}/man/man1/exiv2.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 )
+
 
 include(cmake/printSummary.cmake)

=== src/CMakeLists.txt ===
# CMakeLists.txt for exiv2 library and command-line program

# Note that this is a hack for testing the internals of the library. If EXIV2_BUILD_UNIT_TESTS==OFF
# Then we only export the symbols that are explicitly exported
if( EXIV2_BUILD_UNIT_TESTS )
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON) # Requires CMake 3.3.3
endif()

include(CMakePackageConfigHelpers)

include_directories(${CMAKE_CURRENT_BINARY_DIR})


add_library( exiv2lib_int OBJECT
    canonmn_int.cpp         canonmn_int.hpp
    casiomn_int.cpp         casiomn_int.hpp
    cr2header_int.cpp       cr2header_int.hpp
    crwimage_int.cpp        crwimage_int.hpp
    fujimn_int.cpp          fujimn_int.hpp
    helper_functions.cpp    helper_functions.hpp
    image_int.cpp           image_int.hpp
    makernote_int.cpp       makernote_int.hpp
    minoltamn_int.cpp       minoltamn_int.hpp
    nikonmn_int.cpp         nikonmn_int.hpp
    olympusmn_int.cpp       olympusmn_int.hpp
    orfimage_int.cpp        orfimage_int.hpp
    panasonicmn_int.cpp     panasonicmn_int.hpp
    pentaxmn_int.cpp        pentaxmn_int.hpp
    rw2image_int.cpp        rw2image_int.hpp
    safe_op.hpp
    samsungmn_int.cpp       samsungmn_int.hpp
    sigmamn_int.cpp         sigmamn_int.hpp
    sonymn_int.cpp          sonymn_int.hpp
    tags_int.cpp            tags_int.hpp
    tiffcomposite_int.cpp   tiffcomposite_int.hpp
    tiffimage_int.cpp       tiffimage_int.hpp
    tiffvisitor_int.cpp     tiffvisitor_int.hpp
    tifffwd_int.hpp
    timegm.h
    unused.h
)

add_library( exiv2lib
    ../include/exiv2/config.h
    ../include/exiv2/exiv2.hpp
    ../include/exiv2/rwlock.hpp
    ../include/exiv2/slice.hpp
    basicio.cpp             ../include/exiv2/basicio.hpp
    bigtiffimage.cpp
    bmpimage.cpp            ../include/exiv2/bmpimage.hpp
    convert.cpp             ../include/exiv2/convert.hpp
    cr2image.cpp            ../include/exiv2/cr2image.hpp
    crwimage.cpp            ../include/exiv2/crwimage.hpp
    datasets.cpp            ../include/exiv2/datasets.hpp
    easyaccess.cpp          ../include/exiv2/easyaccess.hpp
    epsimage.cpp            ../include/exiv2/epsimage.hpp
    error.cpp               ../include/exiv2/error.hpp
    exif.cpp                ../include/exiv2/exif.hpp
    futils.cpp              ../include/exiv2/futils.hpp
    gifimage.cpp            ../include/exiv2/gifimage.hpp
    http.cpp                ../include/exiv2/http.hpp
    image.cpp               ../include/exiv2/image.hpp
    ini.cpp                 ../include/exiv2/ini.hpp
    iptc.cpp                ../include/exiv2/iptc.hpp
    jp2image.cpp            ../include/exiv2/jp2image.hpp
    jpgimage.cpp            ../include/exiv2/jpgimage.hpp
    metadatum.cpp           ../include/exiv2/metadatum.hpp
    mrwimage.cpp            ../include/exiv2/mrwimage.hpp
    orfimage.cpp            ../include/exiv2/orfimage.hpp
    pgfimage.cpp            ../include/exiv2/pgfimage.hpp
    preview.cpp             ../include/exiv2/preview.hpp
    properties.cpp          ../include/exiv2/properties.hpp
    psdimage.cpp            ../include/exiv2/psdimage.hpp
    rafimage.cpp            ../include/exiv2/rafimage.hpp
    rw2image.cpp            ../include/exiv2/rw2image.hpp
    tags.cpp                ../include/exiv2/tags.hpp
    tgaimage.cpp            ../include/exiv2/tgaimage.hpp
    tiffimage.cpp           ../include/exiv2/tiffimage.hpp
    types.cpp               ../include/exiv2/types.hpp
    value.cpp               ../include/exiv2/value.hpp
    version.cpp             ../include/exiv2/version.hpp
    webpimage.cpp           ../include/exiv2/webpimage.hpp
    xmp.cpp                 ../include/exiv2/xmp_exiv2.hpp
    xmpsidecar.cpp          ../include/exiv2/xmpsidecar.hpp
    $<TARGET_OBJECTS:exiv2lib_int>
)

generate_export_header(exiv2lib
    EXPORT_MACRO_NAME EXIV2API
    EXPORT_FILE_NAME ${CMAKE_BINARY_DIR}/exiv2lib_export.h
    STATIC_DEFINE exiv2lib_STATIC
)

# Conditional addition of sources to library targets
# ---------------------------------------------------------

if( EXIV2_ENABLE_WEBREADY )
    if( EXIV2_ENABLE_CURL)
        target_sources(exiv2lib PRIVATE easyaccess.cpp ../include/exiv2/easyaccess.hpp)
    endif()

    if( EXIV2_ENABLE_SSH )
        target_sources(exiv2lib PRIVATE ssh.cpp ../include/exiv2/ssh.hpp)
    endif()
endif()

if( EXIV2_ENABLE_PNG )
    target_sources(exiv2lib_int PRIVATE pngchunk_int.cpp)
    target_sources(exiv2lib PRIVATE pngimage.cpp ../include/exiv2/pngimage.hpp)
endif()

if( EXIV2_ENABLE_VIDEO )
    target_sources(exiv2lib PRIVATE
        asfvideo.cpp            ../include/exiv2/asfvideo.hpp
        matroskavideo.cpp       ../include/exiv2/matroskavideo.hpp
        quicktimevideo.cpp      ../include/exiv2/quicktimevideo.hpp
        riffvideo.cpp           ../include/exiv2/riffvideo.hpp
        utilsvideo.cpp          ../include/exiv2/utilsvideo.hpp
    )
endif()

# Other library target properties
# ---------------------------------------------------------

if (${CMAKE_CXX_COMPILER_ID} STREQUAL GNU)
    # Do not check format overflows on this file, to skip a false positive warning
    set_source_files_properties(value.cpp PROPERTIES COMPILE_FLAGS -Wno-format-overflow)
endif()

set_target_properties( exiv2lib PROPERTIES
    VERSION       ${PROJECT_VERSION}
    SOVERSION     ${PROJECT_VERSION_MINOR}
    OUTPUT_NAME   exiv2
    PDB_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMPILE_FLAGS ${EXTRA_COMPILE_FLAGS}
)

if (MSVC)
    set_target_properties(exiv2lib PROPERTIES LINK_FLAGS "/ignore:4099")
endif()

set_target_properties( exiv2lib_int PROPERTIES
    POSITION_INDEPENDENT_CODE ON
    COMPILE_DEFINITIONS exiv2lib_EXPORTS
)

target_include_directories(exiv2lib_int PRIVATE ${ZLIB_INCLUDE_DIR})
target_include_directories(exiv2lib PRIVATE ${ZLIB_INCLUDE_DIR})

if (EXIV2_ENABLE_XMP)
    target_link_libraries(exiv2lib PRIVATE exiv2-xmp)
elseif(EXIV2_ENABLE_EXTERNAL_XMP)
    target_link_libraries(exiv2lib PUBLIC ${XMPSDK_LIBRARY})
    target_include_directories(exiv2lib PUBLIC ${XMPSDK_INCLUDE_DIR})
    target_compile_definitions(exiv2lib PUBLIC EXV_ADOBE_XMPSDK=2016)
endif()

# Use include/exiv2 to build libary code
target_include_directories(exiv2lib PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/exiv2>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
)

target_include_directories(exiv2lib_int PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/exiv2>
)

if (EXIV2_ENABLE_WEBREADY)

    if( EXIV2_ENABLE_SSH )
        target_link_libraries(exiv2lib PUBLIC ssh)
    endif()

    if( EXIV2_ENABLE_CURL )
        target_include_directories(exiv2lib SYSTEM PRIVATE ${CURL_INCLUDE_DIR} )
        target_link_libraries(exiv2lib PRIVATE ${CURL_LIBRARIES})
        if (USING_CONAN)
            target_compile_definitions(exiv2lib PRIVATE ${CONAN_COMPILE_DEFINITIONS_LIBCURL})
            target_link_libraries(exiv2lib PRIVATE ${CONAN_EXE_LINKER_FLAGS_LIBCURL})
            if ( MSVC ) 
                target_link_libraries(exiv2lib PRIVATE Crypt32)
            elseif (NOT APPLE)
                target_link_libraries(exiv2lib PRIVATE CONAN_PKG::OpenSSL)
            endif()
        endif()
    endif()

endif()

if (WIN32)
    target_compile_definitions(exiv2lib PRIVATE PSAPI_VERSION=1) # to be compatible with <= WinVista (#905)
endif()

if (NOT MSVC)
    if ( CMAKE_SYSTEM_NAME STREQUAL "FreeBSD" )
        target_link_libraries( exiv2lib PRIVATE -lprocstat)
    endif()

    if (CYGWIN OR MINGW OR MSYS)
        target_link_libraries( exiv2lib PRIVATE psapi ws2_32 shell32 )
    endif()

    target_link_libraries( exiv2lib PRIVATE Threads::Threads)
else()
    target_link_libraries( exiv2lib PRIVATE psapi ws2_32 shell32 )
endif()

if( EXIV2_ENABLE_PNG )
    target_link_libraries( exiv2lib PRIVATE ${ZLIB_LIBRARIES} )
endif()

if( EXIV2_ENABLE_NLS )
    target_link_libraries(exiv2lib PRIVATE ${Intl_LIBRARIES})
    target_include_directories(exiv2lib PRIVATE ${Intl_INCLUDE_DIRS})
    target_include_directories(exiv2lib_int PRIVATE ${Intl_INCLUDE_DIRS})
    # Definition needed for translations
    target_compile_definitions(exiv2lib PUBLIC EXV_LOCALEDIR="/../${CMAKE_INSTALL_LOCALEDIR}")
endif()

if( ICONV_FOUND )
    target_link_libraries( exiv2lib PRIVATE Iconv::Iconv )
endif()

write_basic_package_version_file(exiv2ConfigVersion.cmake COMPATIBILITY ExactVersion)

install(TARGETS exiv2lib EXPORT exiv2Config
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(FILES
    ${CMAKE_BINARY_DIR}/exv_conf.h
    ${CMAKE_BINARY_DIR}/exiv2lib_export.h
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/exiv2)

install(EXPORT exiv2Config DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/exiv2")

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/exiv2ConfigVersion.cmake DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/exiv2")

# ******************************************************************************
# exiv2 application

if(EXIV2_BUILD_EXIV2_COMMAND)
    add_executable( exiv2
         exiv2.cpp
         exiv2app.hpp
         actions.cpp actions.hpp
         getopt.cpp getopt.hpp
         utils.cpp utils.hpp
    )

    set_target_properties( exiv2 PROPERTIES
        COMPILE_FLAGS ${EXTRA_COMPILE_FLAGS}
        XCODE_ATTRIBUTE_GCC_GENERATE_DEBUGGING_SYMBOLS[variant=Debug] "YES"
    )

    target_link_libraries( exiv2 PRIVATE exiv2lib )

    if( EXIV2_ENABLE_NLS )
        target_link_libraries(exiv2 PRIVATE ${Intl_LIBRARIES})
        target_include_directories(exiv2 PRIVATE ${Intl_INCLUDE_DIRS})
    endif()

    if (USING_CONAN AND WIN32 AND EXISTS ${PROJECT_BINARY_DIR}/conanDlls)
        # In case of using conan recipes with their 'shared' option turned on, we will have dlls of
        # the 3rd party dependencies in the conanDlls folder.

        # Copy 3rd party DLLs the bin folder. [build step]
        add_custom_command(TARGET exiv2 POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy_directory ${PROJECT_BINARY_DIR}/conanDlls ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})

        # Copy 3rd party DLLs the bin folder. [install step]
        install(DIRECTORY ${PROJECT_BINARY_DIR}/conanDlls/ DESTINATION bin)
    endif()

    install(TARGETS exiv2 RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

# That's all Folks!
##

=== xmpsdk/CMakeLists.txt ===
add_library(exiv2-xmp STATIC
    src/ExpatAdapter.cpp
    src/MD5.cpp
    src/ParseRDF.cpp
    src/UnicodeConversions.cpp
    src/WXMPIterator.cpp
    src/WXMPMeta.cpp
    src/WXMPUtils.cpp
    src/XML_Node.cpp
    src/XMPCore_Impl.cpp
    src/XMPIterator.cpp
    src/XMPMeta-GetSet.cpp
    src/XMPMeta-Parse.cpp
    src/XMPMeta-Serialize.cpp
    src/XMPMeta.cpp
    src/XMPUtils-FileInfo.cpp
    src/XMPUtils.cpp
    include/MD5.h
    include/TXMPIterator.hpp
    include/TXMPMeta.hpp
    include/TXMPUtils.hpp
    include/XMP_Const.h
    include/XMP_Environment.h
    include/XMP.incl_cpp
    include/XMPSDK.hpp
    include/XMP_Version.h
)

target_link_libraries(exiv2-xmp
    PRIVATE 
        ${EXPAT_LIBRARY}
)

target_include_directories(exiv2-xmp
    PUBLIC 
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/xmpsdk/include>
    PRIVATE 
        ${EXPAT_INCLUDE_DIR}
)

# Prevent a denial-service-attack related to XML entity expansion
# ("billion laughs attack").
# See https://bugzilla.redhat.com/show_bug.cgi?id=888769
target_compile_definitions(exiv2-xmp PRIVATE BanAllEntityUsage=1)
if (MSVC)
    target_compile_definitions(exiv2-xmp PRIVATE XML_STATIC)
endif()

check_include_file( "stdint.h"  EXV_HAVE_STDINT_H )
if (EXV_HAVE_STDINT_H)
    target_compile_definitions(exiv2-xmp PRIVATE EXV_HAVE_STDINT_H)
endif()

if (BUILD_SHARED_LIBS)
    set_property(TARGET exiv2-xmp PROPERTY POSITION_INDEPENDENT_CODE ON)
endif()

# 1119  Install libxmp.a for use by third party applications (Thanks, Emmanuel)
install(TARGETS exiv2-xmp EXPORT exiv2Config
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

=== debian/changelog ===
exiv2 (0.27.3-3+deb11u2) bullseye; urgency=medium

  * Non-maintainer upload by the LTS Team.
  * Fix CVE-2021-3482 (Closes: #986888)
  * Fix CVE-2021-29458 (Closes: #987277)
    + This is a more complete fix of duplicate CVE-2021-31292
  * Fix CVE-2021-29463 (Closes: #988241)
  * Fix CVE-2021-29464 (Closes: #988242)
  * Fix CVE-2021-29470 (Closes: #987450)
  * Fix CVE-2021-29473 (Closes: #987736)
  * Fix CVE-2021-29623 (Closes: #988481)
  * Fix CVE-2021-32815 (Closes: #992705)
  * Fix CVE-2021-34334 (Closes: #992706)
  * Fix CVE-2021-34335 (Closes: #992707)
  * Fix CVE-2021-37615
    + Also fixes CVE-2021-37616
  * Fix CVE-2021-37618
  * Fix CVE-2021-37619
  * Fix CVE-2021-37620
  * Fix CVE-2021-37621
  * Fix CVE-2021-37622
  * Fix CVE-2021-37623
  * Run unit and python tests without making the build fail.

 -- Helmut Grohne <helmut@subdivi.de>  Thu, 05 Jan 2023 18:19:20 +0100

exiv2 (0.27.3-3+deb11u1) bullseye-security; urgency=medium

  * CVE-2021-31291 (Closes: #991705)
  * CVE-2021-31292 (Closes: #991706)

 -- Moritz Muehlenhoff <jmm@debian.org>  Fri, 06 Aug 2021 10:57:42 +0200

exiv2 (0.27.3-3) unstable; urgency=medium

  * Team upload.
  * Update symbols file from the logs of buildds.

 -- Pino Toscano <pino@debian.org>  Sun, 09 Aug 2020 07:15:23 +0200

exiv2 (0.27.3-2) unstable; urgency=medium

  * Team upload.
  * Limit -fcf-protection only on x86 architectures, as it does not exist
    elsewhere; patch fcf-protection-only-on-x86.diff.

 -- Pino Toscano <pino@debian.org>  Sun, 09 Aug 2020 00:51:27 +0200

exiv2 (0.27.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release:
    - fixes CVE-2019-17402 (Closes: #946341)
  * Update the patches:
    - fix-man-page-table-formatting.patch: refresh
    - remove-execute-permission-bit-from-ini-test-sample.patch: not needed as
      patch, it will be done with a simpler chmod
    - Fix-issue-712.patch: drop, backported from upstream
    - Add-comment-to-explain-choice-of-cut-off-value.patch: drop, backported
      from upstream
    - Fix-1011-fix_1011_jp2_readmetadata_loop.patch: drop, backported from
      upstream
    - drop debian/source/include-binaries, no more needed now
  * Update symbols file. (Closes: #950631, #957188)
  * Add Rules-Requires-Root: no.
  * Append -Wno-deprecated-declarations to the CXXFLAGS: exiv2 uses
    std::auto_ptr<> a lot, so avoid the lots of deprecation warnings.
  * Remove the executable permissions from all the .ini files in libexiv2-doc.
  * Explicitly add the gettext build dependency.
  * Do not ship TODO in libexiv2-doc, as it is not useful for users.

 -- Pino Toscano <pino@debian.org>  Sat, 08 Aug 2020 23:23:52 +0200

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,20 @@
 Source: exiv2
 Section: graphics
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
-Uploaders: Mark Purcell <msp@debian.org>,
-           Steve M. Robbins <smr@debian.org>,
+Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
+Uploaders: Mark Purcell <msp@debian.org>, Steve M. Robbins <smr@debian.org>,
            Maximiliano Curia <maxy@debian.org>
 Build-Depends: chrpath,
                cmake,
                debhelper-compat (= 12),
+               gettext,
                libexpat1-dev,
+               libgtest-dev <!nocheck>,
                pkg-kde-tools,
                zlib1g-dev
 Build-Depends-Indep: doxygen, graphviz, libjs-jquery, xsltproc
 Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: https://www.exiv2.org/
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/exiv2
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/exiv2.git

=== debian/rules ===
--- 
+++ 
@@ -1,13 +1,17 @@
 #!/usr/bin/make -f
+
+# exiv2 uses std::auto_ptr<> a lot, so avoid the lots of deprecation warnings
+export DEB_CXXFLAGS_MAINT_APPEND = -Wno-deprecated-declarations
 
 CMAKE_COMMON_ARGS = \
 	-DEXIV2_ENABLE_NLS=ON \
 	-DEXIV2_ENABLE_VIDEO=ON \
 	-DEXIV2_ENABLE_WEBREADY=ON \
-	-DEXIV2_BUILD_SAMPLES=OFF
+	-DEXIV2_BUILD_SAMPLES=$(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON) \
+	-DEXIV2_BUILD_UNIT_TESTS=$(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON)
 
 %:
-	dh $@ --with pkgkde_symbolshelper --buildsystem cmake
+	dh $@ --with pkgkde_symbolshelper --buildsystem cmake --builddirectory=build
 
 override_dh_auto_configure-indep:
 	dh_auto_configure -- \
@@ -19,6 +23,9 @@
 	dh_auto_configure -a -- \
 	    $(CMAKE_COMMON_ARGS)
 
+override_dh_strip:
+	dh_strip --dbgsym-migration='libexiv2-dbg (<= 0.25-4~~)'
+
 override_dh_install:
 	dh_install
 	find $(CURDIR)/debian -type f -name exiv2 | xargs /usr/bin/chrpath -d
@@ -26,6 +33,18 @@
 override_dh_auto_build-indep:
 	dh_auto_build
 	dh_auto_build -- doc
+
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+override_dh_auto_test:
+	cp debian/test_data/* test/data/
+	# Ignore errors, because they were never enabled in bullseye before
+	# and we don't know whether they pass on all architectures.
+	-./build/bin/unit_tests
+	# Ignore errors, because
+	# bugfixes.github.test_issue_ghsa_mvc4_g5pv_4qqq.JpegBasePrintStructureInfiniteLoop
+	# produces a different error message than expected.
+	-$(MAKE) -C test python_tests
+endif
 
 override_dh_installdocs:
 	dh_installdocs -A -Xcmd.txt -XMakefile -Xtemplates -XChangeLog
@@ -38,5 +57,9 @@
 override_dh_compress:
 	dh_compress -X.xls -X.js -X.idx -X.xml -X.php -X.cpp
 
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym
+override_dh_fixperms-indep:
+	dh_fixperms -i
+	find $(CURDIR)/debian/libexiv2-doc -name '*.ini' -exec chmod -x {} \;
+
+execute_after_dh_clean:
+	for f in debian/test_data/*; do rm -f "test/$${f#debian/test_}"; done
